﻿using igGrid_Post_Data_NetCore.Models;
using Infragistics.Web.Mvc;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;

namespace igGrid_Post_Data_NetCore.Controllers
{
    public class HomeController : Controller
    {
        public List<Product> Products { get; set; } = new List<Product>();
        private readonly ILogger<HomeController> _logger;

        public HomeController(ILogger<HomeController> logger)
        {
            _logger = logger;

            var products = new List<Product>();
            for (int i = 0; i < 5; i++)
            {
                products.Add(new Product { Id = i, Name = $"Name {i}", UnitPrice = 100 });
            }
            this.Products = products;
        }

        public IActionResult Index()
        {
            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }

        public IActionResult GetData()
        {
            return Json(this.Products);
        }

        public IActionResult UpdateData()
        {
            GridModel m = new GridModel();
            var headerData = HttpContext.Request.Form["code"];
            Debug.WriteLine(headerData);
            var gridTransactions = 
                m.LoadTransactions<Product>(HttpContext.Request.Form["gridTransactions"]);
            Debug.WriteLine(gridTransactions);
            // ... 任意の処理(例：変更内容をデータベースへ反映する) ...

            // レスポンス
            Dictionary<string, bool> response = new Dictionary<string, bool>();
            response.Add("Success", true);
            JsonResult result = new JsonResult(response);
            return result;
        }
    }
}
